package org.commonjava.tensor.neo4j.data.store;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

import org.commonjava.tensor.data.store.IndexStore;
import org.commonjava.tensor.data.store.IndexStoreFactory;
import org.neo4j.graphdb.GraphDatabaseService;

import com.google.gson.reflect.TypeToken;

@ApplicationScoped
public class Neo4jIndexStoreFactory
    implements IndexStoreFactory
{

    @Inject
    private GraphDatabaseService graph;

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType, final Class<V> valueType )
    {
        return new GraphIndexStore<K, V>( name, graph );
    }

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType, final TypeToken<V> valueType )
    {
        return new GraphIndexStore<K, V>( name, graph );
    }

}
